#****************************************************************************
#**
#**  File     :  /cdimage/units/UAL0303/UAL0303_script.lua
#**  Author(s):  John Comes, David Tomandl
#**
#**  Summary  :  Aeon Siege Assault Bot Script
#**
#**  Copyright  2005 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************

local AWalkingLandUnit = import('/lua/aeonunits.lua').AWalkingLandUnit
local ADFLaserHighIntensityWeapon = import('/lua/aeonweapons.lua').ADFLaserHighIntensityWeapon
local EffectUtil = import('/lua/EffectUtilities.lua')
local Entity = import('/lua/sim/Entity.lua').Entity
local explosion = import('/lua/defaultexplosions.lua')
local EffectTemplate = import('/lua/EffectTemplates.lua')
local EffectUtilities = import('/lua/EffectUtilities.lua')
local Game = import('/lua/game.lua')
local utilities = import('/lua/utilities.lua')
local Shield = import('/lua/shield.lua').Shield
local UnitShield = import('/lua/shield.lua').UnitShield
local AntiArtilleryShield = import('/lua/shield.lua').AntiArtilleryShield
local Buff = import('/lua/sim/buff.lua')
local AIUtils = import('/lua/ai/aiutilities.lua')

UAL0303 = Class(AWalkingLandUnit) {    
    Weapons = {
        FrontTurret01 = Class(ADFLaserHighIntensityWeapon) {}
    },

    CreateBuildEffects = function( self, unitBeingBuilt, order )
        EffectUtil.CreateAeonCommanderBuildingEffects( self, unitBeingBuilt, self:GetBlueprint().General.BuildBones.BuildEffectBones, self.BuildEffectsBag )
    end,    

    OnCreate = function(self)
        AWalkingLandUnit.OnCreate(self)
    end,


# Shield fix. when the shield is online the unit becomes invulnerable --------------------------------

# original idea (making the unit invulnerable) by deadMG and Ze_PilOt. Heavily modified to incorporate events by
# brute51.

    RegisterEventCallbacks = function(self)
        # setting event callbacks. These were specifically added to cure this bug.
        self:AddUnitCallback(self.OnHarbringerShieldUp, 'OnShieldIsUp')
        self:AddUnitCallback(self.OnHarbringerShieldDown, 'OnShieldIsDown')
    end,

    OnHarbringerShieldUp = function (self)
        self:SetCanTakeDamage(false) 
    end,

    OnHarbringerShieldDown = function (self)
        self:SetCanTakeDamage(true) 
    end,

#end shield fix -------------------------------------

}

TypeClass = UAL0303  